aboutsummaryrefslogtreecommitdiffhomepage
path: root/src/tools/xcode
diff options
context:
space:
mode:
authorGravatar Dave MacLachlan <dmaclach@google.com>2015-09-29 19:21:29 +0000
committerGravatar Florian Weikert <fwe@google.com>2015-09-30 09:35:49 +0000
commit0bb2f0201bda365348f9543d83e53fa90b9134d0 (patch)
treee5d0df1136aa1312296b3abc7946d07f0cfcafe7 /src/tools/xcode
parent1726affaca7be2707f1e462c8e1ba783f4e1770f (diff)
Move actoolzip, momczip and swiftstdlibtoolzip to tools/xcode and convert them to scripts instead of java apps.
RELNOTES: actoolzip, momczip and swiftstdlibtoolzip have all been made into bash scripts and have been renamed to actoolwrapper, momcwrapper and swiftstdlibtoolwrapper respectively. The old versions will be deleted in a later change. -- MOS_MIGRATED_REVID=104225062
Diffstat (limited to 'src/tools/xcode')
-rw-r--r--src/tools/xcode/actoolwrapper/BUILD12
-rw-r--r--src/tools/xcode/actoolwrapper/README6
-rwxr-xr-xsrc/tools/xcode/actoolwrapper/actoolwrapper.sh72
-rwxr-xr-xsrc/tools/xcode/ibtoolwrapper/ibtoolwrapper.sh18
-rw-r--r--src/tools/xcode/momcwrapper/BUILD12
-rw-r--r--src/tools/xcode/momcwrapper/README6
-rwxr-xr-xsrc/tools/xcode/momcwrapper/momcwrapper.sh40
-rw-r--r--src/tools/xcode/swiftstdlibtoolwrapper/BUILD12
-rw-r--r--src/tools/xcode/swiftstdlibtoolwrapper/README6
-rwxr-xr-xsrc/tools/xcode/swiftstdlibtoolwrapper/swiftstdlibtoolwrapper.sh40
10 files changed, 218 insertions, 6 deletions
diff --git a/src/tools/xcode/actoolwrapper/BUILD b/src/tools/xcode/actoolwrapper/BUILD
new file mode 100644
index 0000000000..79bfdd6eda
--- /dev/null
+++ b/src/tools/xcode/actoolwrapper/BUILD
@@ -0,0 +1,12 @@
+package(default_visibility = ["//src/test:__subpackages__"])
+
+filegroup(
+ name = "srcs",
+ srcs = glob(["**"]),
+)
+
+sh_binary(
+ name = "actoolwrapper",
+ srcs = ["actoolwrapper.sh"],
+ data = ["//src/tools/xcode/realpath:realpath_genrule"],
+)
diff --git a/src/tools/xcode/actoolwrapper/README b/src/tools/xcode/actoolwrapper/README
new file mode 100644
index 0000000000..d274e63ec1
--- /dev/null
+++ b/src/tools/xcode/actoolwrapper/README
@@ -0,0 +1,6 @@
+actoolwrapper runs actool, which compiles asset catalog files.
+actoolwrapper then zips up the output, because actool returns an unpredictable
+number of output files.
+
+actool only runs on Darwin, so actoolwrapper only runs on Darwin.
+
diff --git a/src/tools/xcode/actoolwrapper/actoolwrapper.sh b/src/tools/xcode/actoolwrapper/actoolwrapper.sh
new file mode 100755
index 0000000000..21fb17fc93
--- /dev/null
+++ b/src/tools/xcode/actoolwrapper/actoolwrapper.sh
@@ -0,0 +1,72 @@
+#!/bin/bash
+#
+# Copyright 2015 The Bazel Authors. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+# actoolwrapper runs actool and zips up the output.
+# This script only runs on darwin and you must have Xcode installed.
+#
+# $1 OUTZIP - the path to place the output zip file.
+
+set -eu
+
+OUTZIP=$(tools/objc/realpath "$1")
+shift 1
+TEMPDIR=$(mktemp -d -t actoolZippingOutput)
+trap "rm -rf \"$TEMPDIR\"" EXIT
+
+# actool needs to have absolute paths sent to it, so we call realpaths on
+# on all arguments seeing if we can expand them.
+# The argument for --output-partial-info-plist doesn't actually exist at the
+# time of flag parsing, so we create it so that we can call realpaths on it
+# to make the path absolute.
+# actool and ibtool appear to depend on the same code base.
+# Radar 21045660 ibtool has difficulty dealing with relative paths.
+
+TOOLARGS=()
+LASTARG=""
+for i in $@; do
+ if [ "$LASTARG" = "--output-partial-info-plist" ]; then
+ touch "$i"
+ fi
+ if [ -e "$i" ]; then
+ ARG=$(tools/objc/realpath "$i")
+ TOOLARGS+=("$ARG")
+ else
+ TOOLARGS+=("$i")
+ fi
+ LASTARG="$i"
+done
+
+# If we are running into problems figuring out actool issues, there are a couple
+# of env variables that may help. Both of the following must be set to work.
+# IBToolDebugLogFile=<OUTPUT FILE PATH>
+# IBToolDebugLogLevel=4
+# you may also see if
+# IBToolNeverDeque=1
+# helps.
+# Yes IBTOOL appears to be correct here due to actool and ibtool being based
+# on the same codebase.
+/usr/bin/xcrun actool --errors --warnings --notices \
+ --compress-pngs --output-format human-readable-text \
+ --compile "$TEMPDIR" "${TOOLARGS[@]}"
+
+# Need to push/pop tempdir so it isn't the current working directory
+# when we remove it via the EXIT trap.
+pushd "$TEMPDIR" > /dev/null
+# Reset all dates to Zip Epoch so that two identical zips created at different
+# times appear the exact same for comparison purposes.
+find . -exec touch -h -t 198001010000 {} \;
+zip --symlinks --recurse-paths --quiet "$OUTZIP" .
+popd > /dev/null
diff --git a/src/tools/xcode/ibtoolwrapper/ibtoolwrapper.sh b/src/tools/xcode/ibtoolwrapper/ibtoolwrapper.sh
index 4418dd6153..b8252ac01b 100755
--- a/src/tools/xcode/ibtoolwrapper/ibtoolwrapper.sh
+++ b/src/tools/xcode/ibtoolwrapper/ibtoolwrapper.sh
@@ -1,4 +1,5 @@
#!/bin/bash
+#
# Copyright 2015 The Bazel Authors. All rights reserved.
#
# Licensed under the Apache License, Version 2.0 (the "License");
@@ -27,8 +28,9 @@ set -eu
OUTZIP=$(tools/objc/realpath "$1")
ARCHIVEROOT="$2"
shift 2
-TEMPDIR=$(mktemp -d -t ZippingOutput)
+TEMPDIR=$(mktemp -d -t ibtoolZippingOutput)
trap "rm -rf \"$TEMPDIR\"" EXIT
+
FULLPATH="$TEMPDIR/$ARCHIVEROOT"
PARENTDIR=$(dirname "$FULLPATH")
mkdir -p "$PARENTDIR"
@@ -37,12 +39,13 @@ FULLPATH=$(tools/objc/realpath "$FULLPATH")
# IBTool needs to have absolute paths sent to it, so we call realpaths on
# on all arguments seeing if we can expand them.
# Radar 21045660 ibtool has difficulty dealing with relative paths.
-IBTOOLARGS=()
+TOOLARGS=()
for i in $@; do
if [ -e "$i" ]; then
- IBTOOLARGS+=($(tools/objc/realpath "$i"))
+ ARG=$(tools/objc/realpath "$i")
+ TOOLARGS+=("$ARG")
else
- IBTOOLARGS+=($i)
+ TOOLARGS+=("$i")
fi
done
@@ -55,10 +58,13 @@ done
# helps.
/usr/bin/xcrun ibtool --errors --warnings --notices \
--auto-activate-custom-fonts --output-format human-readable-text \
- --compile "$FULLPATH" ${IBTOOLARGS[@]}
+ --compile "$FULLPATH" "${TOOLARGS[@]}"
# Need to push/pop tempdir so it isn't the current working directory
# when we remove it via the EXIT trap.
pushd "$TEMPDIR" > /dev/null
-zip -y -r -q "$OUTZIP" .
+# Reset all dates to Zip Epoch so that two identical zips created at different
+# times appear the exact same for comparison purposes.
+find . -exec touch -h -t 198001010000 {} \;
+zip --symlinks --recurse-paths --quiet "$OUTZIP" .
popd > /dev/null
diff --git a/src/tools/xcode/momcwrapper/BUILD b/src/tools/xcode/momcwrapper/BUILD
new file mode 100644
index 0000000000..61acf80960
--- /dev/null
+++ b/src/tools/xcode/momcwrapper/BUILD
@@ -0,0 +1,12 @@
+package(default_visibility = ["//src/test:__subpackages__"])
+
+filegroup(
+ name = "srcs",
+ srcs = glob(["**"]),
+)
+
+sh_binary(
+ name = "momcwrapper",
+ srcs = ["momcwrapper.sh"],
+ data = ["//src/tools/xcode/realpath:realpath_genrule"],
+)
diff --git a/src/tools/xcode/momcwrapper/README b/src/tools/xcode/momcwrapper/README
new file mode 100644
index 0000000000..37654de429
--- /dev/null
+++ b/src/tools/xcode/momcwrapper/README
@@ -0,0 +1,6 @@
+momcwrapper runs momc, which compiles xcdatamodels.
+momcwrapper then zips up the output, because momc returns an unpredictable
+number of output files.
+
+momc only runs on Darwin, so momcwrapper only runs on Darwin.
+
diff --git a/src/tools/xcode/momcwrapper/momcwrapper.sh b/src/tools/xcode/momcwrapper/momcwrapper.sh
new file mode 100755
index 0000000000..43c03695f4
--- /dev/null
+++ b/src/tools/xcode/momcwrapper/momcwrapper.sh
@@ -0,0 +1,40 @@
+#!/bin/bash
+#
+# Copyright 2015 The Bazel Authors. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+# momcwrapper runs momc and zips up the output.
+# This script only runs on darwin and you must have Xcode installed.
+#
+# $1 OUTZIP - the path to place the output zip file.
+# $2 NAME - output file name
+
+set -eu
+
+OUTZIP=$(tools/objc/realpath "$1")
+NAME="$2"
+shift 2
+TEMPDIR=$(mktemp -d -t momcZippingOutput)
+trap "rm -rf \"$TEMPDIR\"" EXIT
+
+/usr/bin/xcrun momc "$@" "$TEMPDIR/$NAME"
+
+# Need to push/pop tempdir so it isn't the current working directory
+# when we remove it via the EXIT trap.
+pushd "$TEMPDIR" > /dev/null
+# Reset all dates to Zip Epoch so that two identical zips created at different
+# times appear the exact same for comparison purposes.
+find . -exec touch -h -t 198001010000 {} \;
+zip --symlinks --recurse-paths --quiet "$OUTZIP" .
+popd > /dev/null
diff --git a/src/tools/xcode/swiftstdlibtoolwrapper/BUILD b/src/tools/xcode/swiftstdlibtoolwrapper/BUILD
new file mode 100644
index 0000000000..1a98848a4b
--- /dev/null
+++ b/src/tools/xcode/swiftstdlibtoolwrapper/BUILD
@@ -0,0 +1,12 @@
+package(default_visibility = ["//src/test:__subpackages__"])
+
+filegroup(
+ name = "srcs",
+ srcs = glob(["**"]),
+)
+
+sh_binary(
+ name = "swiftstdlibtoolwrapper",
+ srcs = ["swiftstdlibtoolwrapper.sh"],
+ data = ["//src/tools/xcode/realpath:realpath_genrule"],
+)
diff --git a/src/tools/xcode/swiftstdlibtoolwrapper/README b/src/tools/xcode/swiftstdlibtoolwrapper/README
new file mode 100644
index 0000000000..e99ff4ed02
--- /dev/null
+++ b/src/tools/xcode/swiftstdlibtoolwrapper/README
@@ -0,0 +1,6 @@
+swiftstdlibtoolwrapper runs swift-stdlib-tool, which scans executables and
+copies required Swift framework dylibs to the specified path, then zips up
+the output for further bundle merging.
+
+swift-stdlib-tool only runs on Darwin, so swiftstdlibtoolwrapper only runs on
+Darwin.
diff --git a/src/tools/xcode/swiftstdlibtoolwrapper/swiftstdlibtoolwrapper.sh b/src/tools/xcode/swiftstdlibtoolwrapper/swiftstdlibtoolwrapper.sh
new file mode 100755
index 0000000000..208f22e35e
--- /dev/null
+++ b/src/tools/xcode/swiftstdlibtoolwrapper/swiftstdlibtoolwrapper.sh
@@ -0,0 +1,40 @@
+#!/bin/bash
+#
+# Copyright 2015 The Bazel Authors. All rights reserved.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+# swiftstdlibtoolwrapper runs swift-stdlib-tool and zips up the output.
+# This script only runs on darwin and you must have Xcode installed.
+#
+# $1 OUTZIP - the path to place the output zip file.
+
+set -eu
+
+OUTZIP=$(tools/objc/realpath "$1")
+shift 1
+TEMPDIR=$(mktemp -d -t swiftstdlibtoolZippingOutput)
+trap "rm -rf \"$TEMPDIR\"" EXIT
+
+FULLPATH="$TEMPDIR/Frameworks"
+
+/usr/bin/xcrun swift-stdlib-tool --copy --verbose --destination "$FULLPATH" "$@"
+
+# Need to push/pop tempdir so it isn't the current working directory
+# when we remove it via the EXIT trap.
+pushd "$TEMPDIR" > /dev/null
+# Reset all dates to Zip Epoch so that two identical zips created at different
+# times appear the exact same for comparison purposes.
+find . -exec touch -h -t 198001010000 {} \;
+zip --symlinks --recurse-paths --quiet "$OUTZIP" .
+popd > /dev/null